unit LDNgraphics1u1; 

(*Ver 27 Dec 13, 11:06
 To go with...
 http://sheepdogguides.com/lut/lt1Graphics.htm
*)

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type
  { TForm1 }
    TForm1 = class(TForm)
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
  private
    Bitmap:TBitmap;
    iImageLeft, iImageTop, iImageWidth, iImageHeight:integer;
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
iImageLeft:=50;
iImageTop:=10;
iImageWidth:=200;
iImageHeight:=100;

Image1.left:=iImageLeft;
Image1.top:=iImageTop;
Image1.width:=iImageWidth;
Image1.height:=iImageHeight;

(*Next, assign bitmap to the image...
This had benefits in Delphi... I think it
was to do with getting what you see on
the screen to survive re-sizings, etc.

Some examples of Lazarus graphics on the web
take a different approach... they simply put a bitmap
directly on the main form. They don't bother
with the image... but they also over-ride the
built in "Paint" handler to do it. I haven't
found problems with my "simpler" approach, at
least not under Delphi, and this little
Lazarus "demo" program works.*)

Bitmap:=TBitmap.create;//Create a bitmap object
Bitmap.width:=iImageWidth;//Assign dimensions
Bitmap.height:=iImageHeight;

//In Delphi, bitmap background is white to begin with. Black in Lazarus
Bitmap.canvas.pen.color:=clWhite;//1 of 2 lines not needed in Delphi...
Bitmap.canvas.Rectangle(0,0,iImageWidth,iImageHeight);//2 of 2 not needed, Delphi

Image1.Picture.Graphic:=Bitmap; //Assign the bitmap to the image component

//Now do some "tricks" with what we have, and learn
//  where "the edges" of the drawable area are...

//From top left, across top
Image1.Picture.Bitmap.canvas.pen.color:=clGreen;
Image1.Picture.Bitmap.canvas.moveto(0,0);
Image1.Picture.Bitmap.canvas.lineto(150,0);

//From top left, along left edge
Image1.Picture.Bitmap.canvas.pen.color:=clRed;
Image1.Picture.Bitmap.canvas.moveto(0,0);
Image1.Picture.Bitmap.canvas.lineto(0,60);

//From bottom right, up right hand edge
//n.b. the "-1" s
Image1.Picture.Bitmap.canvas.pen.color:=clBlack;
Image1.Picture.Bitmap.canvas.moveto(iImageWidth-1,iImageHeight-1);
Image1.Picture.Bitmap.canvas.lineto(iImageWidth-1,40);

//From bottom right, left along bottom edge
//n.b. the "-1" s
Image1.Picture.Bitmap.canvas.pen.color:=clLime;
Image1.Picture.Bitmap.canvas.moveto(iImageWidth-1,iImageHeight-1);
Image1.Picture.Bitmap.canvas.lineto(50,iImageHeight-1);

//Make an individual pixel black...
//Look closely at the screen when you loop for
//  this... the pixel may be very small
Image1.Picture.Bitmap.canvas.pixels[10,20] := clBlack;

//Text on a graphic...
//    A variety of "pen" properties can be set
//    before calling...
Image1.Picture.Bitmap.canvas.textout(10,30,'Hello');
end;

end.

